Attribute VB_Name = "Create_Aggregates"
Option Explicit
Dim NoOfTables As Integer, NoOfMaps As Integer
Dim map(1 To 40, 0 To 40) As Integer 'map of counts to marginals (1:40)
                                              'by mapping (1:40)
                                              '-1 = marginal; >0 = contributor to marginal
                                              'table 0: 1= row marg; 2=col marg.
Dim NoOfSamples As Integer
Dim MaxContribCells As Integer, MaxCellTypeII As Integer

Dim n_valid_Celltypes As Long 'No. of cell types for given table (where cell 'type' = no. of counts contribiuting to cell count)
Dim n_cells(-2 To 50) As Long 'No. of cells of each cell type for given table
Dim celltype_map(-2 To 50) As Long 'Mapping of valid cell types for given table onto celltype based arrays

Dim inv_celltype_map(-2 To 1600) As Long 'mapping of celltypes onto valid cell types

'========================================================================
'=== On/Off flags

Dim report_area_thresholding As Integer
Dim report_sorting As Integer
Dim Use_Percentages_Switch As Integer
Dim report_sample_membership As Integer
Dim report_table_mapping As Integer
Dim report_percentage_mapping As Integer
Dim strata_switch As Integer

'================================================================================
'======= Declare arrays require to cumulate sample results

' === a) Actual Table totals (based on sum of contributing internal cells; therefore
' ===                         may differ from input [perturbed] table total)


Dim obs_table_total As Double
Dim exp_table_total As Double

' === b) Cell counts
' ===    -5:1000 - Sample no.; 1:40 - col. no.; 1:40 - row. no.

'NoOfSamples x tables x col x row

Dim cell_exp(-5 To 1000, 1 To 40, 1 To 40) As Integer
Dim cell_obs(-5 To 1000, 1 To 40, 1 To 40) As Integer

Dim SAS_Inputs_Path As String
Dim AggregatesPath As String, AggregatesOutputPath As String
Dim PerturbPath As String, PerturbOutputsPath As String, DisclosurePath As String

Sub main()

'File handles
Dim thresholds As Integer, threshlist As Integer, sdc_variants As Integer
Dim agg_output_tables_list As Integer, temp As Integer, tablelist As Integer
Dim file, mapfile As Integer  'input file channels for table and table map data
Dim original_data As Integer, perturbed_data As Integer
Dim original_pctg As Integer, perturbed_pctg As Integer

Dim ED As Integer, Current_ED As Integer
Dim NoOfEDs As Integer, NoOfValidEDs As Integer, NoOfValidEDsinStrata As Integer
Dim sample As Integer

Dim LowerBound_P20 As Long, UpperBound_P20 As Long, LowerBound_P80 As Long, UpperBound_P80 As Long

Dim perturbed_filename As String

Dim rows As Integer, cols As Integer 'no. of rows and columns in each table
Dim TableTotalX As Integer 'X-coord for location of total for table T
Dim TableTotalY As Integer 'Y-coord for location of total for table T

  
Dim contrib_cells(1 To 40, 1 To 40) As Integer 'no. of cells contributing to each marginal
                                               '1:15 - x; 1:40 - y
Dim valid_contrib_cells(1 To 1600) As Integer 'flag for no. of cells (1:1600) on which marginals are based

Dim table(1 To 5500, 0 To 40, 0 To 40) As Integer 'ED x table x col x row x table version
                                                                   'v1 = original; v2 = perturbed
                                                                   'Table(ED,table,0,0,1)=table total

Dim EDName(1 To 5500) As String, All_EDNames(1 To 5500) As String
Dim tablename As String, sdc_var_name As String
Dim strata_source_file As String, strata_name As String, sample_type_name As String
Dim EDs_in_sample(1 To 1000, 1 To 5500) As Integer 'Sample no.; IDs for EDs in sample
Dim Rank_of_EDs_in_sample(1 To 1000, 1 To 5500) As Integer 'Sample no.; Rank of EDs in sample [when sorted by strata]
Dim sample_size As Long, sample_type As Integer
'Dim percentages(1 To 1500, 1 To 100, 1 To 2) As Double '1:1500 - area; 1:100 - percentage; 1:4 - table version
Dim ValidED(1 To 5500) As Integer
Dim strata_data(1 To 5500) As Double, strata_data_map(1 To 5500) As Long
Dim no_of_strata As Integer, strata As Integer, strata_type As String, strata_loop As Integer
Dim LowerBound As Long, UpperBound As Long

'=== Perecentage related arrays ===
Dim percentage_name(1 To 100) As String '1:100 - percentages
Dim no_of_numerators(1 To 100) As Integer '1:100 - percentages
Dim numerator_table(1 To 100, 1 To 20) As String '1:100 - percentages; 1:20 - tables
Dim numerator_row(1 To 100, 1 To 20) As Integer '1:100 - percentages; 1:20 - tables
Dim numerator_col(1 To 100, 1 To 20) As Integer '1:100 - percentages; 1:20 - tables
Dim num_operator(1 To 100, 1 To 20) As String '1:100 - percentages; 1:20 - tables
Dim no_of_denominators(1 To 100) As Integer '1:100 - percentages
Dim denominator_table(1 To 100, 1 To 20) As String '1:100 - percentages; 1:20 - tables
Dim denominator_row(1 To 100, 1 To 20) As Integer '1:100 - percentages; 1:20 - tables
Dim denominator_col(1 To 100, 1 To 20) As Integer '1:100 - percentages; 1:20 - tables
Dim denom_operator(1 To 100, 1 To 20) As String '1:100 - percentages; 1:20 - tables
Dim numerator_map(1 To 100, 1 To 20) '1:100 - perecentages; 1:20 - tables
Dim denominator_map(1 To 100, 1 To 20) '1:100 - perecentages; 1:20 - tables
Dim NoOfPercentages As Integer

Dim cX(1 To 5500), cY(1 To 5500) As Double
Dim NoOfPairs As Integer

SAS_Inputs_Path = "d:\research\disclosure control\disclosure_vb\SAS_Inputs\"
PerturbPath = "d:\research\disclosure control\disclosure_vb\Perturb_v3\"
PerturbOutputsPath = "d:\research\disclosure control\disclosure_vb\Perturb_v3\Outputs\"
AggregatesPath = "d:\research\disclosure control\disclosure_vb\Create_Aggregates_v2\"
AggregatesOutputPath = "d:\research\disclosure control\disclosure_vb\Create_Aggregates_v2\Output\"

'Open files needed throughout run
Call open_general_files(thresholds, threshlist, agg_output_tables_list, temp)
  
'Set sample and other run parameters, including whether or not to use strata...
Call read_run_parameters(NoOfSamples, sample_type, sample_type_name, sample_size, _
  strata_switch, report_area_thresholding, report_sorting, report_sample_membership, _
  report_table_mapping, report_percentage_mapping, Use_Percentages_Switch, _
  strata_source_file, temp)

'Read in percentage mappings (if required...)
'[sub. only runs if Use_Percentages_Switch = 1 or 2]
Call read_percentage_mappings(percentage_name, no_of_numerators, numerator_table, _
  numerator_row, numerator_col, num_operator, no_of_denominators, _
  denominator_table, denominator_row, denominator_col, denom_operator, _
  NoOfPercentages, temp)

'Find no. of EDs per table
Call FindValidEDs(NoOfEDs, NoOfValidEDs, All_EDNames, EDName, ValidED, _
  thresholds, threshlist, report_area_thresholding, temp)

'Check sample type is consistent with strata switch and NoOfValidEDs
Call check_sample_parameters(NoOfSamples, sample_type, sample_size, NoOfValidEDs, _
    strata_switch, temp)

'Read in stratification variables [if required]
strata_name = ""
If (strata_switch = 2) Or (strata_switch = 3) Then _
  Call get_strata_data(strata_data, strata_source_file, strata_name, NoOfEDs, EDName, ValidED, temp)

'Set up loop to repeat sampling process for each strata required

no_of_strata = strata_switch

For strata_loop = 1 To no_of_strata

  'Given strata_switch and strata no., determine type of strata sorting required;
  ' strata(0) [All] = map EDs onto themselves (i.e. leave in user-supplied order)
  ' strata(1) [P20] = sort into ascending order on basis of strata data;
  ' strata(2) [P80] = no sorting required, as data already sorted for previous strata
  
  If strata_switch = 1 Then
    strata = 0
  ElseIf strata_switch = 2 Then
    If strata_loop = 1 Then
      strata = 1
    Else
      strata = 2
    End If
  ElseIf strata_switch = 3 Then
    If strata_loop = 1 Then
      strata = 0
    ElseIf strata_loop = 2 Then
      strata = 1
    ElseIf strata_loop = 3 Then
      strata = 2
    End If
  End If
    
  'Identify strata type (for use in file extensions)
  If strata = 0 Then
    strata_type = "_All"
  ElseIf strata = 1 Then
    strata_type = "_P20"
  ElseIf strata = 2 Then
    strata_type = "_P80"
  End If
        
  Print #temp, "+++ Strata Type: "; strata_type; " (Strata loop "; strata_loop; ") +++"
  Print #temp,
  
  Call sort_strata(strata_data, strata_data_map, NoOfValidEDs, strata, report_sorting, _
    LowerBound_P20, UpperBound_P20, LowerBound_P80, UpperBound_P80, strata_switch, temp)


''''Set up loop to repeat sampling process for two strata (if two strata required);
''''else loop round once only
'''
'''If sort_strata_switch = 1 Then
'''  no_of_strata = 2
'''Else
'''  no_of_strata = 1
'''End If
'''
'''For strata = 1 To no_of_strata

  'open_strata_specific_files
  '(1) Open file containing list of perturbation variants to be processed
  sdc_variants = FreeFile
  Open AggregatesPath & "sdc_variants.txt" For Input As #sdc_variants

'''  'Identify strata type (for use in file extensions)
'''  If sort_strata_switch = 1 Then
'''    If strata = 1 Then
'''      strata_type = "_P20"
'''    Else
'''      strata_type = "_P80"
'''    End If
'''  Else
'''    strata_type = "_All"
'''  End If

  'Create samples, one at a time, for current strata

  For sample = 1 To NoOfSamples 'MUST = NoOfSamples

  If (report_sample_membership = 1) Then Print #temp, "==Sample["; sample; "]=="

  Call select_sample(EDs_in_sample, Rank_of_EDs_in_sample, sample_size, sample_type, _
      NoOfValidEDs, sample, strata, strata_data_map, _
      LowerBound_P20, UpperBound_P20, LowerBound_P80, UpperBound_P80, temp)
     
  Next 'sample

  '==== TABLE SPECIFIC PART =====

'Loop round table-specific part once per table variant required to be processed
Do While Not EOF(sdc_variants)

  Input #sdc_variants, sdc_var_name
  
  Print #temp, "==============================="
  Print #temp, "= SDC Variant: "; sdc_var_name; "            = "
  Print #temp, "==============================="
  Print #temp,

  'Open files required through current variant run
  '(1) list of SAS tables to process
  tablelist = FreeFile
  Open AggregatesPath & "Create_Aggregates_input_tables.txt" For Input As #tablelist

  'Process tables one at a time as read in from list of tables
  Do While Not EOF(tablelist)
  
    Input #tablelist, tablename

    ' Read in table mappings
    Call table_mappings(tablename, temp, rows, cols, contrib_cells, valid_contrib_cells, _
    TableTotalX, TableTotalY)

    'Read in current ED data for current table
    Call get_table(tablename, sdc_var_name, temp, table, rows, cols, All_EDNames, ValidED)

    'Aggregate and write-out table counts for each selected sample
  
     Call aggregate_sample_tables(tablename, sdc_var_name, sample_type_name, strata_name, _
      table, rows, cols, EDs_in_sample, sample_size, NoOfSamples, _
      strata_type, agg_output_tables_list, temp)

  Loop 'Next table

  Close tablelist 'got to end of tablelist

  'if percentages required...
  If (Use_Percentages_Switch = 1) Or (Use_Percentages_Switch = 2) Then
 
     'Use  percentage_mappings to identify, read in, calculate, and write out %s/probs
     Call calc_percentages(percentage_name, no_of_numerators, numerator_table, _
       numerator_row, numerator_col, num_operator, no_of_denominators, _
       denominator_table, denominator_row, denominator_col, denom_operator, _
       numerator_map, denominator_map, NoOfPercentages, _
       sdc_var_name, sample_type_name, strata_name, sample_size, strata_type, temp)

  End If 'if percentages required...

Loop 'next sdc variant

  Close sdc_variants

Next 'next strata_loop

'close all remaining open files
Close thresholds
Close threshlist
Close temp

End Sub

Sub read_run_parameters(NoOfSamples, sample_type, sample_type_name, sample_size, _
  strata_switch, report_area_thresholding, report_sorting, report_sample_membership, _
  report_table_mapping, report_percentage_mapping, Use_Percentages_Switch, _
  strata_source_file, temp)

Dim parameters_in As Integer, label As String

'Open file containing run-specific parameters
parameters_in = FreeFile
Open AggregatesPath & "Create_Aggregates_run_parameters.txt" For Input As #parameters_in

'=== Set sample information

'(a) No. of samples

'NoOfSamples must <= NoOfValidEDs if each ED to be processed in turn;
'Max = 1000

Input #parameters_in, label, NoOfSamples
Print #temp, Trim(label); NoOfSamples

'(b) Stratification switch setting [0 = None; 1 = P20/P80/ 2 = None/P20/P80]
'[If switched on, final part of this sub-routine reads in name of source_file for strata]
Input #parameters_in, label, strata_switch
Select Case strata_switch
Case 1
  Print #temp, Trim(label); strata_switch; " [No strata]"
Case 2
  Print #temp, Trim(label); strata_switch; " [Lower and upper quintile strata]"
Case 3
  Print #temp, Trim(label); strata_switch; " [No Strata; Lower and upper quintile strata]"
End Select



'(c) Sample type [sampling strategy]

'[1=each ED in turn; 2= consecutive EDs; 3 = random EDs];
'*** Option 1 does not work with strata ***

Input #parameters_in, label, sample_type
Print #temp, Trim(label); sample_type; Trim(sample_type_name);
Select Case sample_type
  Case 1
    sample_type_name = "[A]"
    Print #temp, Trim(sample_type_name); _
      " [Each ED in turn (no aggregation)]"
  Case 2
    sample_type_name = "[C]"
    Print #temp, Trim(sample_type_name); _
      " [Consecutive EDs (aggregation)]"
  Case 3
    sample_type_name = "[R]"
    Print #temp, Trim(sample_type_name); _
      " [Random EDs (aggregation)]"
  Case 4
    sample_type_name = "[G]"
    Print #temp, Trim(sample_type_name); _
      " [Consecutive EDs within Geographical Cluster(aggregation)]"
End Select

'(d) Sample size (no. of areas to be aggregated per sample)

'must = 1 if each ED to be processed in turn

Input #parameters_in, label, sample_size
Print #temp, Trim(label); sample_size, "[i.e. no. of areas aggregated together per sample]"

'==== Set other run-specific parameters

'(a) Area thresholding switch
Input #parameters_in, label, report_area_thresholding
Print #temp, Trim(label); report_area_thresholding; " [1=on; else off]"

'(b) Area sorting switch
Input #parameters_in, label, report_sorting
Print #temp, Trim(label); report_sorting; " [1=on; else off]"

'(c) Sample membership switch
Input #parameters_in, label, report_sample_membership
Print #temp, Trim(label); report_sample_membership; " [1=on; else off]"

'(d) Table mapping switch
Input #parameters_in, label, report_table_mapping
Print #temp, Trim(label); report_table_mapping; " [1=on; else = off]"

'(e) Percentage mapping switch
Input #parameters_in, label, report_percentage_mapping
Print #temp, Trim(label); report_percentage_mapping; " [1=on; else = off]"

'(f) Percentages switch
Input #parameters_in, label, Use_Percentages_Switch
Print #temp, Trim(label); Use_Percentages_Switch; " [1=on; else off]"

Print #temp,

'=== If required, read in name of source file containing data to define strata

If (strata_switch = 2) Or (strata_switch = 3) Then
  Input #parameters_in, label, strata_source_file
  Print #temp, Trim(label); strata_source_file
Else
  strata_source_file = ""
End If

Close #parameters_in

End Sub

Sub check_sample_parameters(NoOfSamples, sample_type, sample_size, NoOfValidEDs, _
    strata_switch, temp)
 
'=== Check sample size and sample type consistent; issue warning if required
  
If ((sample_type = 1) And (strata_switch <> 1)) Then
  MsgBox ("For sample type 1, strata_switch MUST be set to 1; switch has been reset accordingly")
  strata_switch = 1
End If

If ((sample_type = 1) And (sample_size > 1)) Then
  MsgBox ("For sample type 1, sample size MUST be set to 1; sample size has been reset accordingly")
  sample_size = 1
End If
   
If ((sample_type = 1) And (NoOfSamples > NoOfValidEDs)) Then
  MsgBox ("For sample type 1, no. of samples MUST be < no. of input areas; sample size has been reset to no. of input areas")
  NoOfSamples = NoOfValidEDs
End If

If ((sample_type = 4) And (strata_switch <> 1)) Then
  MsgBox ("For sample type 4, strata_switch MUST be set to 1; switch has been reset accordingly")
  strata_switch = 1
End If

If sample_size > NoOfValidEDs Then _
  MsgBox ("Warning: sample size > No. of valid input areas; therefore serial sample will include some input areas more than once")
  
'If (report_sample_membership = 1) Then
'  Print #temp, "Sample size = "; f(sample_size, 8, 0)
'  Print #temp,
'End If

End Sub

Sub get_strata_data(strata_data, strata_source_file, strata_name, NoOfEDs, EDName, ValidED, temp)

Dim tmpEDName As String, area As Double, pop As Double, tmp_strata_data As Double
Dim ED As Integer, ErrorFlag As Integer
Dim header1 As String
Dim strata_in As Integer, vED As Integer

strata_in = FreeFile
Open SAS_Inputs_Path & Trim(strata_source_file) For Input As #strata_in
'Print #temp, "Strata_source_file= "; SAS_Inputs_Path & Trim(strata_source_file)

ErrorFlag = 0
vED = 0

'Print #temp, "In get_strata_data, NoOfEDs= ", NoOfEDs

'Read in and discard header row
Input #strata_in, header1, strata_name

'Read in strata data; save for Valid (above threshold) EDs only
For ED = 1 To NoOfEDs
  
  Input #strata_in, tmpEDName, tmp_strata_data
  'Print #temp, ED, ValidED(ED), tmpEDName, tmp_strata_data
  
  'If above threshold...
  If (ValidED(ED) = 1) Then

    vED = vED + 1
    'Print #temp, ED, ValidED(ED), tmpEDName, tmp_strata_data, vED, EDName(vED)
    
    'Check Name of strata = stored EDName
    If (tmpEDName <> EDName(vED)) And (ErrorFlag <> 1) Then
      ErrorFlag = 1
      MsgBox ("Strata ED <> EDName")
    End If

    strata_data(vED) = tmp_strata_data

    'Test output
    'Print #temp, ED, vED, tmpEDName, EDName(vED), area, pop, strata_data(vED)
  
  End If 'if above threshold
  
Next 'ED

Close strata_in

End Sub

Sub sort_strata(vector_in, vector_map, NoOfValidEDs, strata, report_sorting, _
  LowerBound_P20, UpperBound_P20, LowerBound_P80, UpperBound_P80, strata_switch, temp)

Dim First As Long, Smallest As Long, Current As Long
Dim Q As Double, Qi As Long, Qf As Double, Qvalue As Double
Dim temporary As Double, i As Integer
Dim min As Double, max As Double
Dim Percentile As Integer, Percentile_value_20 As Double, Percentile_Value_80 As Double
Dim vector_copy(1 To 5500) As Double 'should be declared same as vector_in


'Initialise vector_map and vector_copy for FIRST strata LOOP ONLY
'-> For either strata_switch=[All] or [All/P20/P80], first loop = strata 0
'-> For strata_switch=[P20/P80], first loop = strata 1

If ((strata = 0) Or (strata_switch = 2 And strata = 1)) Then
  For i = 1 To NoOfValidEDs
    vector_map(i) = i
    vector_copy(i) = vector_in(i)
  Next i
End If

'If strata=2 (P20), undertake sorting; if strata=3 (P80), skip as sorting
'and assignment of upper/lower bounds already during processing of strata=1 [P20]

If (strata = 1) Then

'1. Sort vector into ascending order

'** Uses 'selection sort' algorithm
    
    
For First = 1 To NoOfValidEDs - 1
  Smallest = First
  For Current = First To NoOfValidEDs
    If (vector_copy(Current) < vector_copy(Smallest)) Then Smallest = Current
  Next Current
  'swap records in copy of vector_in
  temporary = vector_copy(Smallest)
  vector_copy(Smallest) = vector_copy(First)
  vector_copy(First) = temporary
  'Swap records in vector_map
  temporary = vector_map(Smallest)
  vector_map(Smallest) = vector_map(First)
  vector_map(First) = temporary
Next First
  
If (report_sorting = 1) Then
  Print #temp, "i", "vector_in", "vector_map", "vector_copy", "vector_in(vector_map(i))"
  For i = 1 To NoOfValidEDs
    Print #temp, i, vector_in(i), vector_map(i), vector_copy(i), vector_in(vector_map(i))
  Next i
End If
    
'2. Identify minimum
  
min = vector_in(vector_map(1))
    
'3. Identify maximum
max = vector_in(vector_map(NoOfValidEDs))

'4. Identify Q20 (20th percentile)

Percentile = 20

Q = 1# + ((Percentile / 100#) * (NoOfValidEDs - 1))  'as per Excel Q = 1+(p(N-1))
    
Qi = Int(Q) 'Integer part of Q
Qf = Q - Int(Q) 'Fractional part of Q

If (Qi = 0) Then
  Qvalue = vector_in(vector_map(1))
ElseIf (Qi = NoOfValidEDs) Then
  Qvalue = vector_in(vector_map(Qi))
Else '0<Qi<N; interpolate Qvalue
  Qvalue = vector_in(vector_map(Qi)) + ((vector_in(vector_map(Qi + 1)) - vector_in(vector_map(Qi))) * Qf)
End If

Percentile_value_20 = Qvalue
LowerBound_P20 = 1
UpperBound_P20 = Qi

'5. Identify Q80 (80th percentile)

Percentile = 80

Q = 1# + ((Percentile / 100#) * (NoOfValidEDs - 1))  'as per Excel Q = 1+(p(N-1))
    
Qi = Int(Q) 'Integer part of Q
Qf = Q - Int(Q) 'Fractional part of Q

If (Qi = 0) Then
  Qvalue = vector_in(vector_map(1))
ElseIf (Qi = NoOfValidEDs) Then
  Qvalue = vector_in(vector_map(Qi))
Else '0<Qi<N; interpolate Qvalue
  Qvalue = vector_in(vector_map(Qi)) + ((vector_in(vector_map(Qi + 1)) - vector_in(vector_map(Qi))) * Qf)
End If

Percentile_Value_80 = Qvalue
LowerBound_P80 = Qi
UpperBound_P80 = NoOfValidEDs

End If 'if strata sorting required (strata=1)

'5. Report results for current vector
'Print #temp, "Min ", min, " Max ", max
If (strata = 0) Then Print #temp, "Whole dataset, LB: "; 1; " UB: "; NoOfValidEDs
If (strata = 1) Then Print #temp, "20th Percentile, LB: "; LowerBound_P20; " UB: "; UpperBound_P20; " 20%tile value "; Percentile_value_20
If (strata = 2) Then Print #temp, "80th Percentile, LB: "; LowerBound_P80; " UB: "; UpperBound_P80; " 80%tile value "; Percentile_Value_80
Print #temp,


End Sub

Sub FindValidEDs(NoOfEDs, NoOfValidEDs, All_EDNames, EDName, ValidED, _
  thresholds, threshlist, report_area_thresholding, temp)

Dim MinRes As Integer, MinHholds As Integer, Res As Integer, Hholds As Integer
Dim tmpEDName As String

'Read in min. threshold limits for 'valid' area
Input #thresholds, MinRes, MinHholds
Print #temp, "Thresholds:"; " Min Res =    "; MinRes; "; "; " Min Hholds = "; MinHholds

If (report_area_thresholding = 1) Then
  Print #temp,
  Print #temp, "InputArea  Area_name(threshold)  Valid_areas "
End If

NoOfEDs = 0
NoOfValidEDs = 0

'Count no. of EDs; read in name and threshold info.; set to valid/invalid
Do While Not EOF(threshlist)
  
  Input #threshlist, tmpEDName, Res, Hholds
  NoOfEDs = NoOfEDs + 1
  ValidED(NoOfEDs) = 0
  
  All_EDNames(NoOfEDs) = tmpEDName
  If (report_area_thresholding = 1) Then _
    Print #temp, NoOfEDs, All_EDNames(NoOfEDs); "        ";
  
  'Count above threshold EDs; save their names; flag ALL EDs as above/below threshold
  If (Res >= MinRes) And (Hholds >= MinHholds) Then
    NoOfValidEDs = NoOfValidEDs + 1
    EDName(NoOfValidEDs) = All_EDNames(NoOfEDs)
    ValidED(NoOfEDs) = 1
    If (report_area_thresholding = 1) Then _
      Print #temp, NoOfValidEDs
  Else
    If (report_area_thresholding = 1) Then _
      Print #temp, "Sub-threshold_ED"
  End If
  
Loop

Print #temp, "No. of user-supplied areas =   ", NoOfEDs
Print #temp, "No. of above threshold areas = ", NoOfValidEDs
Print #temp,

Close #threshlist
Close #thresholds


End Sub

Sub open_general_files(thresholds, threshlist, agg_output_tables_list, temp)

'Open file containing min threshold counts
thresholds = FreeFile
Open AggregatesPath & "thresholds.txt" For Input As #thresholds

'Open file containing ED threshold data
threshlist = FreeFile
Open SAS_Inputs_Path & "threshold.fmt" For Input As #threshlist

'open file to which list of processed tables is written
'[for use in processing %s, regressions and sdc evaluation etc]

agg_output_tables_list = FreeFile
Open AggregatesPath & "agg_output_tables_list.txt" For Output As #agg_output_tables_list

'open scratch file for run-time reporting
temp = FreeFile
Open AggregatesPath & "Create_Aggregates_temp" & ".txt" For Output As #temp

End Sub

Sub table_mappings(tablename, temp, rows, cols, contrib_cells, valid_contrib_cells, _
  TableTotalX, TableTotalY)
Dim T As Integer, mapping As Integer, rowcol As Integer, x As Integer, y As Integer
Dim marginal As Integer, origvalue As Integer, max_contrib As Integer
Dim CellType As Long, CellTypeI As Long, CellTypeII As Long
Dim tmp_n_cells(-5 To 1600) As Integer 'table x no. of contrib cells
Dim mapfile As Integer
Dim tablemap As String


'Open file containing table-specific row/column marginal mappings
'tablemap = Left(tablename, Len(tablename) - 6) & ".map"
tablemap = Trim(tablename) & ".map"

mapfile = FreeFile
Open PerturbPath & Trim(tablemap) For Input As #mapfile

'Find dimensions of current table
Input #mapfile, rows, cols

'print #temp, "Table "; tablename; " rows "; rows; " cols "; cols

'Set all table cells in the array contrib_cells to 1

For y = 1 To rows
  For x = 1 To cols
    contrib_cells(x, y) = 1
  Next x
Next y


mapping = 0

Do While Not EOF(mapfile)

   mapping = mapping + 1

  'Check to see if mapping is for row or column
  Input #mapfile, rowcol

  'Find no. of cols/rows wide table is, as appropriate

  If (rowcol = 1) Then
    map(mapping, 0) = 1
    x = cols 'Mapping is for row X-cols wide
  End If
  If (rowcol = 2) Then
    map(mapping, 0) = 2
    x = rows 'Mapping is for col X-rows wide
  End If

  'Read in mapping and identify marginal

  For y = 1 To x
    Input #mapfile, map(mapping, y)
    If (map(mapping, y) = -1) Then marginal = y
  Next y 'next row/col

  'print #temp, tablemap; " "; rowcol; " ";
  'For y = 1 to 30
    'print #temp, map(mapping, y); " ";
  'Next y
  'print #temp,
  
  'Count up number of cells contributing to marginal
  
  If (map(mapping, 0) = 1) Then 'col. marginal
    For y = 1 To rows
      origvalue = contrib_cells(marginal, y)
      For x = 1 To cols
        If map(mapping, x) > 0 Then contrib_cells(marginal, y) = _
           contrib_cells(marginal, y) + contrib_cells(x, y)
      Next x 'next col.
      contrib_cells(marginal, y) = contrib_cells(marginal, y) - origvalue
    Next y 'next row
  End If
  
  If (map(mapping, 0) = 2) Then 'row marginal
    For x = 1 To cols
      origvalue = contrib_cells(x, marginal)
      For y = 1 To rows
        If map(mapping, y) > 0 Then contrib_cells(x, marginal) = _
          contrib_cells(x, marginal) + contrib_cells(x, y)
      Next y 'next col.
      contrib_cells(x, marginal) = contrib_cells(x, marginal) - origvalue
    Next x 'next row
  End If

    'Input #original_data, table(ED, 0, 0, 1)

'  Print #temp, "Count_cells"; " Table "; tablename; " Mapping "; mapping; " marginal ", marginal
'  For y = 1 to 30
'    For x = 1 to 30
'      Print #temp, f(contrib_cells(x, y), 5, 0);
'    Next x
'    Print #temp,
'  Next y
  
Loop 'next mapping for current table

NoOfMaps = mapping


'Identify cell containing table total (one w. most contributing cells)
MaxContribCells = 1
TableTotalX = 0 'No table marginal in input table
TableTotalY = 0 'No table marginal in input table
For y = 1 To rows
  For x = 1 To cols
    If (contrib_cells(x, y) > MaxContribCells) Then
      MaxContribCells = contrib_cells(x, y)
      TableTotalX = x
      TableTotalY = y
    End If
  Next x
Next y
'Print #temp, "Table", tablename, "Total located in row "; y; " column "; x


'Report table mapping
If (report_table_mapping = 1) Then
  Print #temp, "Table", tablename, "Total located in row "; TableTotalY; " column "; TableTotalX
  Print #temp, "Table", tablename, "Marginal vs. Internal cells"
  For y = 1 To rows
    For x = 1 To cols
      Print #temp, f(contrib_cells(x, y), 5, 0);
    Next x
    Print #temp,
  Next y
  Print #temp,
End If

'print #temp, "Table ", tablename, "no. of mappings ", mapping

'Record all contributing-cell counts with frequencies > 0

For y = 1 To rows
  For x = 1 To cols
    valid_contrib_cells(contrib_cells(x, y)) = 1
  Next x
Next y


For y = 1 To rows
  For x = 1 To cols

'Identify Cell Type I [internal or marginal]
If (contrib_cells(x, y) = 1) Then CellTypeI = -1 Else CellTypeI = -2
    
'Identify Cell Type II [based on number of cells contributing to error]
'(value ranges from 1 to z, where z is max. no. of cells contributing to
'calculation of a marginal count)
CellTypeII = contrib_cells(x, y)
    
'Cumulate number of cells of each type
tmp_n_cells(CellTypeI) = tmp_n_cells(CellTypeI) + 1   'Internal/Marginal cells
tmp_n_cells(CellTypeII) = tmp_n_cells(CellTypeII) + 1   'No. of contrib. cells
tmp_n_cells(0) = tmp_n_cells(0) + 1   'All table cells


Next x
Next y

'For x = 1 To 1600
'  If valid_contrib_cells(x) > 0 Then
'    Print #temp, "Valid_contrib_cells "; x
'  End If
'Next x


' ========= For table, identify frequency of cells of different types
'           [where 'cell type' = no. of cell counts contributing to given cell value]


'Identify no. of valid Cell types
'[where 'cell type' = no. of cells contributing to cell count]

n_valid_Celltypes = 0
celltype_map(-2) = -2
celltype_map(-1) = -1
celltype_map(0) = 0

n_cells(-2) = tmp_n_cells(-2)
n_cells(-1) = tmp_n_cells(-1)
n_cells(0) = tmp_n_cells(0)

For CellType = 1 To MaxContribCells
  If (tmp_n_cells(CellType) > 0) Then
    n_valid_Celltypes = n_valid_Celltypes + 1
    celltype_map(n_valid_Celltypes) = CellType
    inv_celltype_map(CellType) = n_valid_Celltypes
    n_cells(n_valid_Celltypes) = tmp_n_cells(CellType)
  End If
Next CellType

If (report_table_mapping = 1) Then
  Print #temp, "Table "; tablename
  Print #temp, "No. of contributing cells (Cell Type)", "No. of cells of this type"
  Print #temp, "Marginal ", n_cells(-2)
  Print #temp, "Internal ", n_cells(1)
  Print #temp, "All ", n_cells(0)
  For x = 1 To n_valid_Celltypes
    Print #temp, celltype_map(x), n_cells(x)   'n_cells(celltype_map( x))
  Next x
  Print #temp,
End If


Close mapfile

End Sub

Sub read_percentage_mappings(percentage_name, no_of_numerators, numerator_table, _
  numerator_row, numerator_col, num_operator, no_of_denominators, _
  denominator_table, denominator_row, denominator_col, denom_operator, _
  NoOfPercentages, temp)

Dim percentmap As Integer, NP As Integer, i As Integer, v As Integer
Dim T As Integer, x As Integer, y As Integer, rows As Integer, cols As Integer
Dim num As Integer, denom As Integer


'Only run subroutine if percentages required...
If (Use_Percentages_Switch = 1) Or (Use_Percentages_Switch = 2) Then

  percentmap = FreeFile
  Open AggregatesPath & "Create_Aggregates_percentages.map" For Input As #percentmap

  'Find out how percentages should be stored (rows x cols)
  '(if no. of percentages > max. no. of cols., then allows conversion of
  'percentages from vector to table format)

  Input #percentmap, rows, cols

  'Read in details of how to calculate each percentage required

  NP = 0
  Do While Not EOF(percentmap)

    NP = NP + 1
  
     Input #percentmap, percentage_name(NP)
   
     Input #percentmap, no_of_numerators(NP)
   
     For num = 1 To no_of_numerators(NP)
       Input #percentmap, numerator_table(NP, num), numerator_col(NP, num), numerator_row(NP, num)
       If num <> no_of_numerators(NP) Then Input #percentmap, num_operator(NP, num)
     Next num
   
     Input #percentmap, no_of_denominators(NP)
   
     For denom = 1 To no_of_denominators(NP)
       Input #percentmap, denominator_table(NP, denom), denominator_col(NP, denom), denominator_row(NP, denom)
       If denom <> no_of_denominators(NP) Then Input #percentmap, denom_operator(NP, denom)
     Next denom
   
  Loop 'next percentage mapping

  NoOfPercentages = NP

  Close #percentmap


  'Report percentage mappings [if required]

  If (report_percentage_mapping = 1) Then
    Print #temp,
    Print #temp, "Percentage mappings"
    Print #temp, "Output format for percentages: rows = ", rows, " cols = ", cols
    For NP = 1 To NoOfPercentages
       Print #temp, percentage_name(NP)
       Print #temp, "  no. of numerators: "; no_of_numerators(NP)
       For num = 1 To no_of_numerators(NP)
         Print #temp, "    "; numerator_table(NP, num); " col "; numerator_col(NP, num); " row "; numerator_row(NP, num)
         Print #temp, num_operator(NP, num);
       Next num
       Print #temp,
       Print #temp, "  no. of denoms.: "; no_of_denominators(NP)
       For denom = 1 To no_of_denominators(NP)
         Print #temp, "    "; denominator_table(NP, denom); " col "; denominator_col(NP, denom); " row "; denominator_row(NP, denom)
         Print #temp, denom_operator(NP, denom);
       Next denom
       Print #temp,
    Next NP 'next percentage mapping
  End If 'if report_percentage_mapping = 1 [on]


End If 'if percentages required

End Sub

Sub calc_percentages(percentage_name, no_of_numerators, numerator_table, _
  numerator_row, numerator_col, num_operator, no_of_denominators, _
  denominator_table, denominator_row, denominator_col, denom_operator, _
  numerator_map, denominator_map, NoOfPercentages, _
  sdc_var_name, sample_type_name, strata_name, sample_size, strata_type, temp)


Dim table_data(1 To 20) As Integer, no_of_tables As Integer
Dim tablename(1 To 20) As String
Dim table(1 To 20, 1 To 40, 1 To 40) As Long, table_p(1 To 20, 1 To 40, 1 To 40) As Double
Dim tablelist As Integer, pctgs_out As Integer
Dim T As Integer, P As Integer, num As Integer, denom As Integer
Dim rows(1 To 20) As Integer, cols(1 To 20) As Integer, table_variant_name As String
Dim junk_number As Integer, mapfile As Integer, sample As Integer, x As Integer, y As Integer
Dim percentage(1 To 1000) As Double '1:NoOfSamples
Dim numerator As Double, denominator As Double


'Open list of SAS tables to process
tablelist = FreeFile
Open PerturbPath & "Perturbation input tables.txt" For Input As #tablelist

'open file for output of percentages calculated from aggregation of data
'and write out header consisting of percentage names
'[1 file per strata/sdc/sample type variant; 1 row of output precentages per sample]

pctgs_out = FreeFile
Open AggregatesOutputPath & "percentages" & Trim(sdc_var_name) & _
  Trim(strata_type) & "[" & Trim(strata_name) & "]" & _
   "_n" & sample_size & Trim(sample_type_name) & "_s" & NoOfSamples & ".fmt" For Output As #pctgs_out
For P = 1 To NoOfPercentages
  Print #pctgs_out, """"; percentage_name(P); """,";
Next P
Print #pctgs_out,


'Read in list of tablenames +:
'(i) count no. of tables to be processed
'(ii) read in no. of rows/cols in each table [from table map files]
'(iii) open table data files (for current strata/sdc/sample size variant)

T = 0

Do While Not EOF(tablelist)
  
  T = T + 1
  
  Input #tablelist, tablename(T), junk_number
  
  '(i) Count no. of valid input tables
  no_of_tables = T

  '(ii) Open relevant table map and find no. of rows and cols in table
  mapfile = FreeFile
  Open PerturbPath & Trim(tablename(T)) & ".map" For Input As #mapfile
    Input #mapfile, rows(T), cols(T)
    Print #temp, "Table "; tablename(T); " rows "; rows(T); " cols "; cols(T)
  Close mapfile
  
  '(iii) Open input aggregate sample data for current table
  '[for current strata, sdc and sample size variant]
  table_data(T) = FreeFile
  Open AggregatesOutputPath & Trim(tablename(T)) & Trim(sdc_var_name) & _
    Trim(strata_type) & "[" & Trim(strata_name) & "]" & _
    "_n" & sample_size & Trim(sample_type_name) & "_s" & NoOfSamples & ".fmt" For Input As #table_data(T)
  Print #temp, AggregatesOutputPath & Trim(tablename(T)) & Trim(sdc_var_name) & _
    Trim(strata_type) & "[" & Trim(strata_name) & "]" & _
    "_n" & Trim(sample_type_name) & sample_size & "_s" & NoOfSamples & ".fmt"

Loop 'next table in list

Close tablelist

'Map tables required for percentages on to tablelist

For P = 1 To NoOfPercentages
  
  For num = 1 To no_of_numerators(P)
    For T = 1 To no_of_tables
      If (numerator_table(P, num) = tablename(T)) Then numerator_map(P, num) = T
    Next T
    'Report mapping [if any]
'    Print #temp, "Percentage: "; P; " Numerator: "; num
'    If (numerator_map(P, num) > 0) Then
'      Print #temp, P, numerator_table(P, num), " maps on to tablelist table "; _
'        numerator_map(P, num); " ["; tablename(numerator_map(P, num)); "]"
'    Else
'      Print #temp, "ERROR:"; P, numerator_table(P, num), " does not map on to a table in current tablelist"
'    End If
  Next num
  
  For denom = 1 To no_of_denominators(P)
    denominator_map(P, denom) = 0
    For T = 1 To no_of_tables
      If (denominator_table(P, denom) = tablename(T)) Then denominator_map(P, denom) = T
    Next T
    'Report mapping [if any]
'    Print #temp, "Percentage: "; P; " Denominator: "; denom
'    If (denominator_map(P, denom) > 0) Then
'      Print #temp, P, denominator_table(P, denom), " maps on to tablelist table "; _
'        denominator_map(P, denom); " ["; tablename(denominator_map(P, denom)); "]"
'    Else
'      Print #temp, "ERROR:"; P, denominator_table(P, denom), " does not map on to a table in current tablelist"
'    End If
  Next denom

Next P

'==============================================
'= Calculate percentages                      =
'==============================================

'Scroll through sample aggregates one at a time

For sample = 1 To NoOfSamples

  'Read in data for current sample for ALL tables
  For T = 1 To no_of_tables
  
    'Read in table header and counts (for current sample)
    Input #table_data(T), table_variant_name
    For y = 1 To rows(T)
       For x = 1 To cols(T)
          Input #table_data(T), table(T, x, y)
       Next x
    Next y

    'Write out copy of data
    If sample = NoOfSamples Then
      Print #temp, table_variant_name & " input data..."
      For y = 1 To rows(T)
        For x = 1 To cols(T)
            Print #temp, f(table(T, x, y), 5, 0);
         Next x
         Print #temp,
      Next y
      Print #temp,
    End If

  Next T 'next table

  'Go through percentages one at a time
  
  For P = 1 To NoOfPercentages

    'calculate numerator of current perecentage (comprises 1 or more components)

    For num = 1 To no_of_numerators(P)

'      Print #temp, "Percentage "; percentage_name(P); ": numerator component("; num; _
'        ") table coords x:"; numerator_col(P, num); " y:"; numerator_row(P, num); " = "; _
'        table(numerator_map(P, num), numerator_col(P, num), _
'        numerator_row(P, num)); "    "; num_operator(P, num)
      
      If num = 1 Then
        numerator = table(numerator_map(P, num), numerator_col(P, num), numerator_row(P, num))
      ElseIf num > 1 Then
        If num_operator(P, num - 1) = "+" Then
          numerator = numerator + table(numerator_map(P, num), numerator_col(P, num), numerator_row(P, num))
        ElseIf num_operator(P, num - 1) = "-" Then
           numerator = numerator - table(numerator_map(P, num), numerator_col(P, num), numerator_row(P, num))
        Else
          Print #temp, "ERROR: no valid operator for Perecentage "; percentage_name(P); " numerator "; num
        End If
      End If 'if num =1 or >1
      
    Next num
  
'    Print #temp, "Percentage "; percentage_name(P); ": numerator = "; f(numerator, 8, 2)
  
    'calculate denominator of current perecentage (comprises 1 or more components)

    For denom = 1 To no_of_denominators(P)

'      Print #temp, "Percentage "; percentage_name(P); ": denominator component("; denom; _
'        ") table coords x:"; denominator_col(P, denom); " y:"; denominator_row(P, denom); " = "; _
'        table(denominator_map(P, denom), denominator_col(P, denom), _
'        denominator_row(P, denom)); "    "; denom_operator(P, denom)
      
      If denom = 1 Then
        denominator = table(denominator_map(P, denom), denominator_col(P, denom), denominator_row(P, denom))
      ElseIf denom > 1 Then
        If denom_operator(P, denom - 1) = "+" Then
          denominator = denominator + table(denominator_map(P, denom), denominator_col(P, denom), denominator_row(P, denom))
        ElseIf denom_operator(P, denom - 1) = "-" Then
          denominator = denominator - table(denominator_map(P, denom), denominator_col(P, denom), denominator_row(P, denom))
        Else
          Print #temp, "ERROR: no valid operator for Perecentage "; percentage_name(P); " denominator "; denom
        End If
      End If 'if num =1 or >1
      
    Next denom
  
'    Print #temp, "Percentage "; percentage_name(P); ": denominator = "; f(denominator, 8, 2)
 
    'calculate %
  
    If (denominator > 0#) Then
      percentage(P) = (numerator / denominator) * 100#
    Else
      percentage(P) = -999
    End If
'    Print #temp, "Percentage = "; percentage(P)
  
    If (percentage(P) > 100) Then
      Print #temp, "WARNING: For "; table_variant_name; "calculated percentage>100)"
      Print #temp, "Percentage = "; percentage(P); " numerator "; numerator; " denominator "; denominator
    End If 'if % > 100
'    Print #temp,
  
    'write out precentages calculated from 1st sample

    Print #pctgs_out, f(percentage(P), 8, 4); ",";

  Next P 'percentage
  
  Print #pctgs_out,
  
Next sample

'close all tables

For T = 1 To no_of_tables
  Close table_data(T)
Next T

Close pctgs_out


End Sub
Sub get_table(tablename, sdc_var_name, temp, table, rows, cols, All_EDNames, ValidED)

Dim x As Integer, y As Integer, table_data As Integer
Dim junk_table(1 To 40, 1 To 40) As Integer
Dim message As String
Dim zoneid As String
Dim ED As Integer, v_ED As Integer

'Open table-specific input data file
table_data = FreeFile
Open PerturbOutputsPath & Trim(tablename) & Trim(sdc_var_name) & ".fmt" For Input As #table_data

'Scroll through EDs one at a time (as drawn from....)

ED = 0
v_ED = 0
 
  Do While Not EOF(table_data) 'Must be at least one ED!!
'Do While ED < 20

  ED = ED + 1

  If (ValidED(ED) = 1) Then v_ED = v_ED + 1

  'Print #temp, "*** GET TABLE ***"

  'Read in area name
  Input #table_data, zoneid
  
  'Check to make sure ED has same name as in threshold.fmt
  If Trim(zoneid) <> Trim(All_EDNames(ED)) Then
    message = "Error: area name from input table [" & Trim(zoneid) & _
      "] and list of EDs [" & All_EDNames(ED) & "] do not match"
      MsgBox (message)
      Stop
  End If
  
  If (ValidED(ED) = 1) Then
    'Read in table counts and save
    For y = 1 To rows
      For x = 1 To cols
        Input #table_data, table(v_ED, x, y)
      Next x
    Next y
  ElseIf (ValidED(ED) = 0) Then
    'Read in table counts and discard
    For y = 1 To rows
      For x = 1 To cols
        Input #table_data, junk_table(x, y)
      Next x
    Next y
  End If

  'Write out copy of data
'  Print #temp, EDName(ED) & " input data..."
'  For y = 1 To rows
'     For x = 1 To cols
'        Print #temp, f(table(ED, x, y), 5, 0);
'     Next x
'     Print #temp,
'  Next y
'  Print #temp,

  Loop 'next ED in list

  Print #temp, "No of areas input from " & tablename & " = " & ED & ";  Valid areas = " & v_ED
  Print #temp,
  
Close table_data

End Sub

Sub select_sample(EDs_in_sample, Rank_of_EDs_in_sample, sample_size, sample_type, _
      NoOfValidEDs, sample, strata, vector_map, _
      LowerBound_P20, UpperBound_P20, LowerBound_P80, UpperBound_P80, temp)
  
Dim i As Integer, j As Integer
Dim LowerBound As Long, UpperBound As Long, NoOfValidEDsinStrata As Long

'For current strata, identify upper and lower bounds of EDs to be sampled from
If strata = 0 Then 'no stratification required
  LowerBound = 1
  UpperBound = NoOfValidEDs
ElseIf strata = 1 Then
    LowerBound = LowerBound_P20
    UpperBound = UpperBound_P20
ElseIf strata = 2 Then ' upper 20%
    LowerBound = LowerBound_P80
    UpperBound = UpperBound_P80
End If

NoOfValidEDsinStrata = (UpperBound - LowerBound) + 1

'Given sampling strategy (sample_type), and lower and upper bounds of current strata,
'select sample

If sample_type = 1 Then
'sample = EDs in order in list, starting with first ED and proceeding to sample_size
'** NOT FOR USE WITH STRATA SWITCHED ON ***

  EDs_in_sample(sample, 1) = sample
  Rank_of_EDs_in_sample(sample, i) = vector_map(sample) 'needed for checking purposes only
  'Print #temp, "Areas_in_sample(1)  Area no. ", EDs_in_sample(sample,1)
  'Print #temp,
  
ElseIf sample_type = 2 Then
'sample = EDs in list order, starting at random point (within strata)
'*** IF USED WITH STRATA, CREATES MAXIMALLY HOMOGENISED SAMPLES ***

  'Select random starting place in ED list (starting_place + sample_size <= noofvalideds)

  If sample_size <= NoOfValidEDsinStrata Then
    j = (LowerBound - 1) + Int(Rnd * (NoOfValidEDsinStrata - sample_size)) 'avoid sample 'wrap-around' if possible to max. sample contiguity
  Else
    j = (LowerBound - 1) + Int(Rnd * (NoOfValidEDsinStrata))
  End If

  For i = 1 To sample_size
    j = j + 1
    If j > UpperBound Then j = LowerBound 'trigger sample wrap-around if necessary
    EDs_in_sample(sample, i) = vector_map(j)
    Rank_of_EDs_in_sample(sample, i) = j 'needed for checking purposes only
    'Print #temp, "EDs_in_sample("; i; ")  ED no. ", EDs_in_sample(sample,i)
  Next i 'Next ED in list
  'Print #temp,

ElseIf sample_type = 3 Then
'sample = random selection of EDs within defined strata

  For i = 1 To sample_size

    'select random ED (1:ValidEDs)
    j = (LowerBound - 1) + Int(Rnd * NoOfValidEDsinStrata) + 1
    EDs_in_sample(sample, i) = vector_map(j)
    Rank_of_EDs_in_sample(sample, i) = j 'needed for checking purposes only
    'Print #temp, "EDs_in_sample("; i; ")  ED no. ", EDs_in_sample(sample,i)

  Next i
  'Print #temp,

ElseIf sample_type = 4 Then
'sample = consecutive areas from within geographical cluster
'[starts at random place in cluster; wraps-around if reaches end of cluster]
'*** WILL NOT WORK WITH STRATA... ****
  
  j = Int(Rnd * NoOfValidEDs) + 1 'find random starting ED
  If (j Mod 50) = 0 Then
    LowerBound = j - 49
    UpperBound = j
  Else
    LowerBound = (j - (j Mod 50)) + 1
    UpperBound = (j - (j Mod 50)) + 50
  End If
  
  Print #temp, "sample_type(4): j = "; j; " LowerBound= "; LowerBound; _
    " UpperBound= "; UpperBound
  
  j = j - 1 'because 1 added automatically at start of folloing loop
  For i = 1 To sample_size
    j = j + 1
    If j > UpperBound Then j = LowerBound 'trigger sample wrap-around if necessary
    EDs_in_sample(sample, i) = vector_map(j)
    Rank_of_EDs_in_sample(sample, i) = j
    'print 'temp, "EDs_in_sample("; i; ")  ED no. ", EDs_in_sample(sample,i)
  Next i 'Next ED in list
  'print #temp

End If

If (report_sample_membership = 1) Then
  For i = 1 To sample_size
    Print #temp, "Sample member no.("; f(i, 4, 0); ") Area no. "; _
      f(EDs_in_sample(sample, i), 8, 0); " Rank "; _
      f(Rank_of_EDs_in_sample(sample, i), 8, 0)
  Next i
  Print #temp,
End If

End Sub

Sub aggregate_sample_tables(tablename, sdc_var_name, sample_type_name, strata_name, _
  table, rows, cols, EDs_in_sample, sample_size, _
  NoOfSamples, strata_type, agg_output_tables_list, temp)
Dim s As Integer, x As Integer, y As Integer, ED As Long, agg_table_out As Integer
Dim sample As Integer
Dim agg_table(1 To 40, 1 To 40) As Integer 'no. of cols; no. of rows

  
'Open output file for current table
agg_table_out = FreeFile
Open AggregatesOutputPath & Trim(tablename) & Trim(sdc_var_name) & _
  Trim(strata_type) & "[" & Trim(strata_name) & "]" & _
  "_n" & sample_size & Trim(sample_type_name) & "_s" & NoOfSamples & ".fmt" For Output As #agg_table_out

'Add current table to list of tables to be processed for %s and regression etc.
Print #agg_output_tables_list, AggregatesPath & Trim(tablename) & Trim(sdc_var_name) & _
  Trim(strata_type) & "[" & Trim(strata_name) & "]" & _
  "_n" & sample_size & Trim(sample_type_name) & "_s" & NoOfSamples & ".fmt"

For sample = 1 To NoOfSamples

  'Set agg_table counts to zero
  For y = 1 To rows
    For x = 1 To cols
      agg_table(x, y) = 0
    Next x
  Next y

  'Cumulate table counts for all EDs in sample
  For s = 1 To sample_size

     ED = EDs_in_sample(sample, s)

     For y = 1 To rows
       For x = 1 To cols

         agg_table(x, y) = agg_table(x, y) + table(ED, x, y)
       
      Next x
    Next y
  
  Next s
  
  'Write out aggregated table counts for current sample

  Print #agg_table_out, Trim(tablename) & Trim(sdc_var_name) & _
    Trim(strata_type) & "[" & Trim(strata_name) & "]" & _
    "_n" & sample_size & Trim(sample_type_name) & "_s" & sample
  
  For y = 1 To rows
    For x = 1 To cols
      Print #agg_table_out, agg_table(x, y);
    Next x
    Print #agg_table_out,
  Next y
  
Next sample

Close (agg_table_out)

End Sub

